#!/usr/bin/env python
# coding=utf-8


import os
import re


def test():
    os.chdir('/repo/mindspore/model_zoo/master')
    for ckpt in os.listdir('.'):
        if not ckpt.endswith('.ckpt'):
            continue

        regex = '^(?P<model>.+)_(?P<device>(ascend|gpu|cpu))' \
                '_v130_(?P<dataset>.+)_(?P<source>(official|research))' \
                '_(?P<domain>(cv|nlp|gnn|audio|recommend|rl))' \
                '_(?P<bs>bs\d+)(_(?P<extra>.+))?.ckpt$'
        pattern = re.search(regex, ckpt)
        if pattern is None:
            #import ipdb; ipdb.set_trace()
            #print(ckpt)
            continue

        info = pattern.groupdict()
        print info['domain'], info['model'], info['dataset'], info['device'], info['source'], info['extra']


def main():
    #os.chdir('/repo/mindspore/model_zoo/master')
    os.chdir('/repo/mindspore/model_zoo/tmp')
    models = set()
    for ckpt in os.listdir('.'):
        if not ckpt.endswith('.ckpt'):
            continue

        regex = '^(?P<model>.+)_(?P<device>(ascend|gpu|cpu))' \
                '_v130_(?P<dataset>.+)_(?P<source>(official|research))' \
                '_(?P<domain>(cv|nlp|gnn|audio|recommend|rl))' \
                '_(?P<bs>bs\d+)(_(?P<extra>.+))?.ckpt$'
        pattern = re.search(regex, ckpt)
        if pattern is None:
            #import pdb; pdb.set_trace()
            print(ckpt)
            continue

        info = pattern.groupdict()
        #print info['domain'], info['model'], info['dataset'], info['device'], info['source'], info['extra']
        feature = (info['domain'], info['model'], info['dataset'], info['source'], info['extra'])
        #if feature in models:
        #    print(ckpt)

        models.add(feature)

    #import pdb; pdb.set_trace()


if __name__ == '__main__':
    #test()
    main()

